
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>一个简单的blog系统（三） 增加文件上传功能 / 憋错料</title>

    <meta name="description" content="一个简单的blog系统（三） 增加文件上传功能 1. 一个完整的博客怎么能缺少图片呢,目前上传文件的方法有三种: (1)使用Express自带的文件上传功能,不涉及数据库. (2)使用Formidable外部模块,不涉及数据库. (3)上传到MongoDB,涉及到数据库. 可以看出,第一种方式最简单,Express通过bodyParser()解析请求体,因此我们可以使用bodyParser()来实现文件的上传功能. 2.实现过程 2.1 首先打开header.ejs,在&lt;li&gt;&lt;a href=&quot;/post&quot ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">一个简单的blog系统（三） 增加文件上传功能</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>1. 一个完整的博客怎么能缺少图片呢，目前上传文件的方法有三种：</p>
<p>　　（1）使用Express自带的文件上传功能，不涉及数据库。</p>
<p>　　（2）使用Formidable外部模块，不涉及数据库。</p>
<p>　　（3）上传到MongoDB，涉及到数据库。</p>
<p>　　可以看出，第一种方式最简单，Express通过bodyParser()解析请求体，因此我们可以使用bodyParser()来实现文件的上传功能。</p>
<p>2.实现过程</p>
<p>　　2.1 首先打开header.ejs，在&lt;li&gt;&lt;a href="/post" title=‘发表‘&gt;发表&lt;/a&gt;&lt;/li&gt;，前面添加一行代码：</p>
<pre>&lt;li&gt;&lt;a href="/upload" title="上传"&gt;上传&lt;/a&gt;&lt;/li&gt;</pre>
<p>　　2.2 然后，打开index.js，在app.get(‘/logout‘)函数后添加如下代码：</p>
<pre> 1 //上传文件页路由
 2 router.get(‘/upload‘, checkLogin);    //限定只有登录的用户才能上传文件
 3 router.get(‘/upload‘, function(req, res) {
 4     res.render(‘upload‘, {
 5         title: ‘文件上传‘,
 6         user: req.session.user,
 7         success: req.flash(‘success‘).toString(),
 8         error: req.flash(‘error‘).toString()
 9     });
10 });</pre>
<p>　　2.3 其次，我们在views文件夹下面新建upload.ejs，添加如下代码：</p>
<pre> 1 &lt;div class=‘container‘&gt;
 2     &lt;h2&gt;文件上传&lt;/h2&gt;
 3     &lt;hr/&gt;
 4     &lt;form enctype="multipart/form-data" method="post" action="/upload" class="form-horizontal"&gt;
 5         &lt;div class="form-group"&gt;
 6           &lt;label for="file1"&gt;文件输入&lt;/label&gt;
 7           &lt;input type="file" name="file1"&gt;
 8        &lt;/div&gt;
 9        &lt;div class="form-group"&gt;
10           &lt;label for="file1"&gt;文件输入&lt;/label&gt;
11           &lt;input type="file" name="file1"&gt;
12        &lt;/div&gt;
13        &lt;div class="form-group"&gt;
14           &lt;label for="file1"&gt;文件输入&lt;/label&gt;
15           &lt;input type="file" name="file1"&gt;
16        &lt;/div&gt;
17        &lt;button type="submit" class="btn btn-primary"&gt;上传&lt;/button&gt;
18    &lt;/form&gt;
19 &lt;/div&gt;</pre>
<p>　　2.4 然后，修改app.js，添加如下代码：</p>
<pre> 1 var multer  = require(‘multer‘);
 2 // 文件上传插件
 3 var storage = multer.diskStorage({
 4   destination: function (req, file, cb) {
 5     cb(null, ‘./public/images/user‘)
 6   },
 7   filename: function (req, file, cb) {
 8     cb(null, file.fieldname + ‘-‘ + Date.now())
 9   }
10 });
11 app.use(multer({ storage: storage }).any());</pre>
<p>　　2.5 现在我们现在只是有了一个可以上传文件的表单而已，并不能上传文件，接下来我们添加对上传文件的支持。在 router.get(‘/upload‘) 后添加如下代码：</p>
<pre>router.post(‘/upload‘, checkLogin);
router.post(‘/upload‘, function (req, res) {
  req.flash(‘success‘, ‘文件上传成功!‘);
  res.redirect(‘/upload‘);
});</pre>
<p>　　至此，我们就给博客添加了文件上传功能。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-01-30 11:42:18 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>一个简单的blog系统（三） 增加文件上传功能的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02RDrA0.html" rel="bookmark">Node&period;js 博客实例（三）增加文件上传功能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原教程 https://github.com/nswbmw/N-blog/wiki/_pages的第三章 上传文件目前有三种方法: 使用 Express 自带的文件上传功能,不涉及数据库 使用 Formidable 外部模块,不涉及数据库 上传到 MongoDB ,涉及数据库 这里使用第一种,用户将文件上,存储于:blog/public/images/目录下. blog/views/header.ejs  在&lt;span&gt;&lt;a title=&quot;发表&quot; href=&quot			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDbDdK3.html" rel="bookmark">一个简单的jQuery插件ajaxfileupload实现ajax上传文件例子</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				页面代码:   &lt;html&gt;     &lt;!-- 引入相关的js文件,相对路径  --&gt;     &lt;script type=&quot;text/javascript&quot; src=&quot;js/jquery.js&quot;&gt;&lt;/script&gt;       &lt;script type=&quot;text/javascript&quot; src=&quot;js/ajaxfileupload.js&quot;&gt;&lt;/script&g			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MP8jg6M.html" rel="bookmark">nodejs 实现简单的文件上传功能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先需要大家看一下目录结构,然后开始一点开始我们的小demo. 文件上传总计分为三种方式: 1.通过flash,activeX等第三方插件实现文件上传功能. 2.通过html的form标签实现文件上传功能,优点:浏览器兼容好. 3.通过xhr level2的异步请求,可以百度formData对象. 这里使用2做个练习. node插件请看下package.json文件 { &quot;name&quot;: &quot;upload&quot;, &quot;version&quot;: &quot;0.1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWeeK63.html" rel="bookmark">Node&period;js 博客实例（三）添加文件上传功能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原教程 https://github.com/nswbmw/N-blog/wiki/_pages的第三章 上传文件眼下有三种方法: 使用 Express 自带的文件上传功能,不涉及数据库 使用 Formidable 外部模块,不涉及数据库 上传到 MongoDB ,涉及数据库 这里使用第一种,用户将文件上,存储于:blog/public/images/文件夹下. blog/views/header.ejs  在&lt;span&gt;&lt;a title=&quot;发表&quot; href=&quo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OkP7g3.html" rel="bookmark">nodejs&plus;ajax实现简单的文件上传功能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				app.js中引入express的第三方中间件multer实现文件上传功能. var multer = require('multer');//用express的第三方中间件 multer 实现文件上传功能. app.use(multer({//设置文件上传到的位置 dest: './public/images/upload', rename: function (fieldname, filename) { return filename; } })); 路由 app.post('/uploa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xA8Yj3.html" rel="bookmark">MVC中使用Ajax和HTML5实现文件上传功能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言 在实际编程中,经常遇到实现文件上传并显示上传进度的功能,基于此目的,本文就为大家介绍不使用flash 或任何上传文件的插件来实现带有进度显示的文件上传功能. 基本功能:实现带有进度条的文件上传功能 高级功能:通过拖拽文件的操作实现多个文件上传功能 背景 HTML5提供了一种标准的访问本地文件的方法——File API规格说明,通过调用File API 能够访问文件信息,也可以利用客户端来验证上传文件的类型和大小是否规范. 该规格说明包含以下几个接口来使用文件: File接口:具有文件的“读			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0K7wOy0.html" rel="bookmark">MVC5：使用Ajax和HTML5实现文件上传功能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言 在实际编程中,经常遇到实现文件上传并显示上传进度的功能,基于此目的,本文就为大家介绍不使用flash 或任何上传文件的插件来实现带有进度显示的文件上传功能. 基本功能:实现带有进度条的文件上传功能 高级功能:通过拖拽文件的操作实现多个文件上传功能 背景 HTML5提供了一种标准的访问本地文件的方法--File API规格说明,通过调用File API 能够访问文件信息,也可以利用客户端来验证上传文件的类型和大小是否规范. 该规格说明包含以下几个接口来使用文件: File接口:具有文件的&quot;读			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDRaG83.html" rel="bookmark">使用Commons FileUpLoad组件实现文件上传功能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Commons 是Apache开放的源码组织的一个java子项目,该项目主要涉及一些开发中常用的模块,如文件上传,命令行处理,数据库连接池等.FileUpLoad就是其中的一个用于处理HTTP文件上传的子项目.Commons FileUpLoad组建具有以下几个特点: 1.使用简单:Commons FileUpLoad组件可以方便的嵌入JSP文件中,在JSP文件中仅编写少量代码就可完成文件上传功能,十分方便. 2.能够全程控制上传的内容:使用Commons FileUpLoad组件提供的对象及操			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QAoEo4.html" rel="bookmark">配置php&period;ini实现PHP文件上传功能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文介绍了如何配置php.ini实现PHP文件上传功能.其中涉及到php.ini配置文件中的upload_tmp_dir.upload_max_filesize.post_max_size等选项,这些选项是文件上传成败的关键.我们以php.5.3.5的Windows版本为例说明. php.ini中文件上传功能配置选项说明 用文本工具(推荐EditPlus)打开php.ini 配置文件,查找 File Uploads ,在这个区域有以下3个选项: file_uploads = On 是否允许HTT			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/bModx0Z.html" rel="bookmark" class="title">Linux 查看端口使用情况</a>
					<div>
						之前查询端口是否被占用一直搞不明白,问了好多人,终于搞懂了,现在总结下: 1.netstat  -anp  |grep   端口号 如下,我以3306为例,netstat  -anp  |grep   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q3qzgP4.html" rel="bookmark" class="title">Ubuntu配置和修改IP地址</a>
					<div>
						1.修改配置文件/etc/network/interfaces[email protected]:~# sudo gedit /etc/network/interfaces 添加以下内容:auto e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jyBvgM.html" rel="bookmark" class="title">Java的优先级</a>
					<div>
						序列号 符号 名称 结合性(与操作数) 目数 说明 1 . 点 从左到右 双目 ( ) 圆括号 从左到右 [ ] 方括号 从左到右 2 + 正号 从右到左 单目 - 负号 从右到左 单目 ++ 自增  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoQD2k3.html" rel="bookmark" class="title">UVA11389-The Bus Driver Problem</a>
					<div>
						题目链接 题意:n个司机,n个下午路线和n个夜间的行驶时间.每个司机恰好分配到一个下午路线和一个夜间路线.司机行驶如果超过规定的行驶总时间,每个单位时间要多付给司机r元,求最小要给所有司机的加班费.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JkKnlM.html" rel="bookmark" class="title">python内置函数总结</a>
					<div>
						取绝对值的内置函数: abs print(bas(-9)) #-9的绝对值会被打印出来 2. 处理可迭代对象的函数(一):all name = (&quot;Tom&quot;,&quot;Jack& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZA9od0.html" rel="bookmark" class="title">数据库表设计原则</a>
					<div>
						(1)不应针对整个系统进行数据库设计,而应该根据系统架构中的组件划分,针对每个组件所处理的业务进行组件单元的数据库设计:不同组件间所对应的数据库 表之间的关联应尽可能减少,如果不同组件间的表需要外键关 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mg52kR3.html" rel="bookmark" class="title">zjut  1179 平均数</a>
					<div>
						平均数  Time Limit:1000MS  Memory Limit:32768K Description: 求若干个整数的平均数. Input: 输入数据含有不多于5组的数据,每组数据由一个整数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kDaGj3.html" rel="bookmark" class="title">第三次作业&plus;105032014117</a>
					<div>
						测试帖链接:http://www.cnblogs.com/yuj-zh/p/6627266.html 1.修正流程图 2.测试用例设计 3.单元测试框架 4.测试结果 5.测试小结 通过本次实验我基本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyK5JL3.html" rel="bookmark" class="title">Chapter 2 Open Book&amp;mdash&semi;&amp;mdash&semi;13</a>
					<div>
						&quot;People in this town,&quot; he muttered. &quot;Dr. Cullen is a brilliant surgeon who could prob ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MomqEk3.html" rel="bookmark" class="title">Nginx On rhel6&period;4</a>
					<div>
						平台为:rhel 6.4 32bit 一.安装Nginx: 1.解决依赖关系 # yum groupinstall &quot;Development Tools&quot; &quot;Server ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz1ZrJ4.html" rel="bookmark" class="title">二分Kmeans的java实现</a>
					<div>
						刚刚研究了Kmeans.Kmeans是一种十分简单的聚类算法.可是他十分依赖于用户最初给定的k值.它无法发现随意形状和大小的簇.最适合于发现球状簇.他的时间复杂度为O(tkn).kmeans算法有两个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qExzW3.html" rel="bookmark" class="title">西方哲学笔记</a>
					<div>
						西方哲学跟东方思维方式的差别是如此之大,乃至于经过翻译后的西方哲学书籍几乎全部走味.即使读翻译后的西方哲学原本原著,仍然很难体会西方哲学究竟想说什么.本文如果严格按照西方哲学的表述方式,读者一定会是在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Moa2xy3.html" rel="bookmark" class="title">用&OpenCurlyDoubleQuote;道&rdquo;的思想解决费用流问题---取&sol;不取皆是取 （有下界-&amp;gt&semi;有上界） &sol; ACdreamoj 1171</a>
					<div>
						题意: 给一个矩阵,给出约束:i(0&lt;i&lt;n)行至少去ai个数,j行至少取bi个数,要求取的数值之和最小. 开始一见,就直接建了二分图,但是,发现这是有下界无上界最小费用流问题,肿么办.. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41zGEOM.html" rel="bookmark" class="title">LINQ操作符二：SelectMany</a>
					<div>
						SelectMany操作符提供了将多个from子句组合起来的功能,相当于数据库中的多表连接查询,它将每个对象的结果合并成单个序列. 示例: 1 using System; 2 using System ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YDWwwM.html" rel="bookmark" class="title">SVG&period;js 引用获取整理</a>
					<div>
						一.SVG.get() 根据id获取元素 var draw = SVG('svg1').size(300, 300); var circle = draw.circle(50); circle.fil ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MERXnQ0.html" rel="bookmark" class="title">All about Built-inTypes</a>
					<div>
						1,Every identifier in a Java program has a type associated with it. 当你使用任何variable的时候,第一件事情是告诉你可爱的编译 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lk2KXM.html" rel="bookmark" class="title">hdu2030</a>
					<div>
						汉字统计 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submis ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGR2Oo4.html" rel="bookmark" class="title">1-6-Xmanager远程工具的使用</a>
					<div>
						Xmanager远程工具的使用  					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzEo8k4.html" rel="bookmark" class="title">设计模式&mdash;&mdash;装饰模式（Decorator）</a>
					<div>
						要想正确理解设计模式,首先必须明确它是为了解决什么问题而提出来的. 设计模式学习笔记 --Shulin 转载请注明出处:http://blog.csdn.net/zhshulin 1.概念 装饰模式又 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME6LXZ0.html" rel="bookmark" class="title">Linux 权限管理之二：setuid、setgid 和 sticky bit</a>
					<div>
						Linux 下的文件和文件夹除了拥有 rwx 这三种基本权限以外,还可能有三种特殊的权限:setuid(SUID).setgid(SGID)和sticky bit(SBIT),其具体描述如下: set ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.022 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
